--**use at your own risk**--

--Particle Flow Spliner
--this script draws splines along the path all particls within a flow based
--on a specified time increment.

--Usage--
--Set endOFPRAnimation, endFrame, and fIncrmnt vaiables as desired
--Select a Particle Flow scene object and run the script.

--written by Charley Carlat
--Update -- This script was written long ago and may have many areas for improvement

pf = $
i2 = 1
pTest = false
endOfPFAnimation = 40--set to the end of particle animation (to determin total number of particles)
endFrame = 40--sets the end frame of splining calculation
fIncrmnt = 2--sets the increment of frames per spline knot

-----Checking for all valid particle by sliderTIme specified above--------
sliderTime = endOfPFAnimation
while not pTest do
(
	pf.particleIndex = i2
	if pf.particlePosition == [0,0,0] then
	(
		pTest = true
		global numParts = i2 - 1
	)--End If
	i2 += 1
)--End Do
--------------------------------Creating shapes-----------------------------
for i in 1 to numParts do
(
	newShp = splineShape()
	addNewSpline newShp
	newShp.name = ("PF-Shape_" + i as string)
)--end For
-------------------Adding Knots to Splines at specified intervals-------------
for t in 0 to (endFrame/fIncrmnt) do-- the "to" number here defines the multiplier or total number of knots
(
	sliderTime = (t * fIncrmnt)--sets the sliderTime multiplied by above number
	for i in 1 to numParts do
	(
		pf.particleIndex = i
		pId = pf.particleID
		if pId != 0 then
		(
			stemShp = execute ("$PF-Shape_" + pId as string)
			addKnot stemShp 1 #smooth #curve pf.particlePosition
		)--End If
	)
)--End For

select $'PF-Shape_*'
updateShape $